## mergerfs 2.14.0

=== Makefile ===
#  Copyright (c) 2016, Antonio SJ Musumeci <trapexit@spawn.link>
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice appear in all copies.
#
#  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.


PKGCONFIG =  	$(shell which pkg-config)
GIT 	  = 	$(shell which git)
TAR 	  = 	$(shell which tar)
MKDIR     = 	$(shell which mkdir)
TOUCH 	  = 	$(shell which touch)
CP        = 	$(shell which cp)
RM 	  = 	$(shell which rm)
LN        =     $(shell which ln)
FIND 	  = 	$(shell which find)
INSTALL   = 	$(shell which install)
MKTEMP    = 	$(shell which mktemp)
STRIP     = 	$(shell which strip)
PANDOC    =	$(shell which pandoc)
SED       =     $(shell which sed)
GZIP      =     $(shell which gzip)
RPMBUILD  =     $(shell which rpmbuild)
GIT2DEBCL =     ./tools/git2debcl
CPPFIND   =     ./tools/cppfind

ifeq ($(PKGCONFIG),"")
$(error "pkg-config not installed")
endif

ifeq ($(PANDOC),"")
$(warning "pandoc does not appear available: manpage won't be buildable")
endif

XATTR_AVAILABLE = $(shell test ! -e /usr/include/attr/xattr.h; echo $$?)

FUSE_AVAILABLE = $(shell ! pkg-config --exists fuse; echo $$?)

ifeq ($(FUSE_AVAILABLE),0)
FUSE_AVAILABLE = $(shell test ! -e /usr/include/fuse.h; echo $$?)
endif

ifeq ($(FUSE_AVAILABLE),0)
$(error "FUSE development package doesn't appear available")
endif

FLAG_NOPATH = $(shell $(CPPFIND) "flag_nopath")
FALLOCATE   = $(shell $(CPPFIND) "fuse_fs_fallocate")
FLOCK       = $(shell $(CPPFIND) "fuse_fs_flock")
READ_BUF    = $(shell $(CPPFIND) "fuse_fs_read_buf")
WRITE_BUF   = $(shell $(CPPFIND) "fuse_fs_write_buf")

UGID_USE_RWLOCK = 0

OPTS 	    = -O2
SRC	    = $(wildcard src/*.cpp)
OBJ         = $(SRC:src/%.cpp=obj/%.o)
DEPS        = $(OBJ:obj/%.o=obj/%.d)
TARGET      = mergerfs
MANPAGE     = $(TARGET).1
FUSE_CFLAGS = $(shell $(PKGCONFIG) --cflags fuse)
CFLAGS      = -g -Wall \
	      $(OPTS) \
	      -Wno-unused-result \
              $(FUSE_CFLAGS) \
              -DFUSE_USE_VERSION=26 \
              -MMD \
	      -DFLAG_NOPATH=$(FLAG_NOPATH) \
	      -DFALLOCATE=$(FALLOCATE) \
              -DFLOCK=$(FLOCK) \
	      -DREAD_BUF=$(READ_BUF) \
              -DWRITE_BUF=$(WRITE_BUF) \
	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
LDFLAGS       = $(shell $(PKGCONFIG) fuse --libs)

PREFIX        = /usr/local
EXEC_PREFIX   = $(PREFIX)
DATAROOTDIR   = $(PREFIX)/share
DATADIR       = $(DATAROOTDIR)
BINDIR        = $(EXEC_PREFIX)/bin
SBINDIR       = $(EXEC_PREFIX)/sbin
MANDIR        = $(DATAROOTDIR)/man
MAN1DIR       = $(MANDIR)/man1

INSTALLBINDIR  = $(DESTDIR)$(BINDIR)
INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)

ifeq ($(XATTR_AVAILABLE),0)
$(warning "xattr not available: disabling")
CFLAGS += -DWITHOUT_XATTR
endif

all: $(TARGET)

help:
	@echo "usage: make"
	@echo "make XATTR_AVAILABLE=0 - to build program without xattrs functionality (auto discovered otherwise)"

$(TARGET): src/version.hpp obj/obj-stamp $(OBJ)
	$(CXX) $(CFLAGS) $(OBJ) -o $@ $(LDFLAGS)

mount.mergerfs: $(TARGET)
	$(LN) -fs "$<" "$@"

changelog:
	$(GIT2DEBCL) --name $(TARGET) > ChangeLog

authors:
	$(GIT) log --format='%aN <%aE>' | sort -f | uniq > AUTHORS

src/version.hpp:
	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
	@echo "#ifndef _VERSION_HPP" > src/version.hpp
	@echo "#define _VERSION_HPP" >> src/version.hpp
	@echo "static const char MERGERFS_VERSION[] = \"$(VERSION)\";" >> src/version.hpp
	@echo "#endif" >> src/version.hpp

obj/obj-stamp:
	$(MKDIR) -p obj
	$(TOUCH) $@

obj/%.o: src/%.cpp
	$(CXX) $(CFLAGS) -c $< -o $@

clean: rpm-clean
	$(RM) -rf obj
	$(RM) -f src/version.hpp
	$(RM) -f "$(TARGET)" mount.mergerfs
	$(FIND) . -name "*~" -delete

distclean: clean
	$(GIT) clean -fd

install: install-base install-mount.mergerfs install-man

install-base: $(TARGET)
	$(INSTALL) -v -m 0755 -D "$(TARGET)" "$(INSTALLBINDIR)/$(TARGET)"

install-mount.mergerfs: mount.mergerfs
	$(MKDIR) -p "$(INSTALLBINDIR)"
	$(CP) -a "$<" "$(INSTALLBINDIR)/$<"

install-man: $(MANPAGE)
	$(INSTALL) -v -m 0644 -D "man/$(MANPAGE)" "$(INSTALLMAN1DIR)/$(MANPAGE)"

install-strip: install-base
	$(STRIP) "$(INSTALLBINDIR)/$(TARGET)"

uninstall: uninstall-base uninstall-mount.mergerfs uninstall-man

uninstall-base:
	$(RM) -f "$(INSTALLBINDIR)/$(TARGET)"

uninstall-mount.mergerfs:
	$(RM) -f "$(INSTALLBINDIR)/mount.mergerfs"

uninstall-man:
	$(RM) -f "$(INSTALLMAN1DIR)/$(MANPAGE)"

$(MANPAGE): README.md
ifneq (,$(PANDOC))
	$(PANDOC) -s -t man -o "man/$(MANPAGE)" README.md
endif

man: $(MANPAGE)

tarball: clean man changelog authors src/version.hpp
	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(eval FILENAME := $(TARGET)-$(VERSION))
	$(eval TMPDIR := $(shell $(MKTEMP) --tmpdir -d .$(FILENAME).XXXXXXXX))
	$(MKDIR) $(TMPDIR)/$(FILENAME)
	$(CP) -ar . $(TMPDIR)/$(FILENAME)
	$(TAR) --exclude=.git -cz -C $(TMPDIR) -f $(FILENAME).tar.gz $(FILENAME)
	$(RM) -rf $(TMPDIR)

debian-changelog:
	$(GIT2DEBCL) --name $(TARGET) > debian/changelog

signed-deb: debian-changelog
	dpkg-buildpackage

deb: debian-changelog
	dpkg-buildpackage -uc -us

rpm-clean:
	$(RM) -rf rpmbuild

rpm: tarball
	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(MKDIR) -p rpmbuild/BUILD rpmbuild/RPMS rpmbuild/SOURCES
	$(SED) 's/__VERSION__/$(VERSION)/g' $(TARGET).spec > \
		rpmbuild/SOURCES/$(TARGET).spec
	cp -ar $(TARGET)-$(VERSION).tar.gz rpmbuild/SOURCES
	$(RPMBUILD) -ba rpmbuild/SOURCES/$(TARGET).spec \
		--define "_topdir $(CURDIR)/rpmbuild"

.PHONY: all clean install help

include $(wildcard obj/*.d)

=== debian/changelog ===
mergerfs (2.14.0-1) unstable; urgency=medium

  * Initial release. (Closes: #832443)
  * [8f00ca2] Imported Upstream version 2.14.0
  * [3329c8d] Add initial debian/ work
  * [8289526] Add source packaging format
  * [bc4964d] Add patch to disable (useless) dist-clean
  * [0e9cb85] Enable hardening
  * [6d0aada] Update Makefile to include hardening flags
  * [52929c4] Add Vcs headers
  * [0f5eac0] Fix indentation of extended description
  * [fe1d768] Fix spelling error in package description

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 26 Jul 2016 13:54:30 +0530

## mergerfs 2.16.1

=== Makefile ===
--- 
+++ 
@@ -71,7 +71,7 @@
 	      $(OPTS) \
 	      -Wno-unused-result \
               $(FUSE_CFLAGS) \
-              -DFUSE_USE_VERSION=26 \
+              -DFUSE_USE_VERSION=29 \
               -MMD \
 	      -DFLAG_NOPATH=$(FLAG_NOPATH) \
 	      -DFALLOCATE=$(FALLOCATE) \

=== debian/changelog ===
mergerfs (2.16.1-1) unstable; urgency=medium

  * [cdc8ebd] New upstream version 2.16.1

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 29 Sep 2016 22:32:43 +0530

mergerfs (2.16.0-1) unstable; urgency=medium

  * [05be9d6] New upstream version 2.16.0

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 14 Sep 2016 20:37:15 +0530

mergerfs (2.15.0-1) unstable; urgency=medium

  * [a668581] Add README.Debian to explain tmpfs on /tmp use case
  * [7661f71] Add fuse's default_permissions option to make it behave
    more in line with standard file systems
  * [a75cc49] Imported Upstream version 2.15.0
  * [ad87171] Refine debian/copyright file
  * [36db803] Add patch to avoid upstream's gitignore

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 26 Aug 2016 15:34:50 +0530

## mergerfs 2.17.0

=== Makefile ===
--- 
+++ 
@@ -143,14 +143,16 @@
 install: install-base install-mount.mergerfs install-man
 
 install-base: $(TARGET)
-	$(INSTALL) -v -m 0755 -D "$(TARGET)" "$(INSTALLBINDIR)/$(TARGET)"
+	$(MKDIR) -p "$(INSTALLBINDIR)"
+	$(INSTALL) -v -m 0755 "$(TARGET)" "$(INSTALLBINDIR)/$(TARGET)"
 
 install-mount.mergerfs: mount.mergerfs
 	$(MKDIR) -p "$(INSTALLBINDIR)"
 	$(CP) -a "$<" "$(INSTALLBINDIR)/$<"
 
 install-man: $(MANPAGE)
-	$(INSTALL) -v -m 0644 -D "man/$(MANPAGE)" "$(INSTALLMAN1DIR)/$(MANPAGE)"
+	$(MKDIR) -p "$(INSTALLMAN1DIR)"
+	$(INSTALL) -v -m 0644 "man/$(MANPAGE)" "$(INSTALLMAN1DIR)/$(MANPAGE)"
 
 install-strip: install-base
 	$(STRIP) "$(INSTALLBINDIR)/$(TARGET)"

=== debian/changelog ===
mergerfs (2.17.0-2) unstable; urgency=medium

  * [420adc6] Add patch to ensure binary has proper version information

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 10 Dec 2016 16:35:51 +0530

mergerfs (2.17.0-1) unstable; urgency=medium

  * [08e6aa5] New upstream version 2.17.0

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 08 Dec 2016 23:29:34 +0530

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_install:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install

## mergerfs 2.18.0

=== Makefile ===
--- 
+++ 
@@ -132,8 +132,12 @@
 	$(CXX) $(CFLAGS) -c $< -o $@
 
 clean: rpm-clean
+ifneq ($(GIT),)
+ifeq  ($(shell test -e .git; echo $$?),0)
+	$(RM) -f src/version.hpp
+endif
+endif
 	$(RM) -rf obj
-	$(RM) -f src/version.hpp
 	$(RM) -f "$(TARGET)" mount.mergerfs
 	$(FIND) . -name "*~" -delete

=== debian/changelog ===
mergerfs (2.18.0-1) unstable; urgency=medium

  * [50aeea4] New upstream version 2.18.0

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 21 Dec 2016 23:00:20 +0530

## mergerfs 2.21.0

=== Makefile ===
--- 
+++ 
@@ -53,6 +53,7 @@
 endif
 
 FLAG_NOPATH = $(shell $(CPPFIND) "flag_nopath")
+FLAG_UTIME  = $(shell $(CPPFIND) "flag_utime_omit_ok")
 FALLOCATE   = $(shell $(CPPFIND) "fuse_fs_fallocate")
 FLOCK       = $(shell $(CPPFIND) "fuse_fs_flock")
 READ_BUF    = $(shell $(CPPFIND) "fuse_fs_read_buf")
@@ -74,6 +75,7 @@
               -DFUSE_USE_VERSION=29 \
               -MMD \
 	      -DFLAG_NOPATH=$(FLAG_NOPATH) \
+	      -DFLAG_UTIME=$(FLAG_UTIME) \
 	      -DFALLOCATE=$(FALLOCATE) \
               -DFLOCK=$(FLOCK) \
 	      -DREAD_BUF=$(READ_BUF) \

=== debian/changelog ===
mergerfs (2.21.0-1) unstable; urgency=medium

  * New upstream version 2.21.0
  * Enable faster builds

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 20 Jun 2017 12:42:59 +0545

mergerfs (2.19.0-1) experimental; urgency=medium

  * New upstream version 2.19.0

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 20 Mar 2017 17:27:16 +0530

=== debian/control ===
Source: mergerfs
Section: utils
Priority: optional
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~),
 libfuse-dev,
 libattr1-dev,
 pkg-config
Standards-Version: 3.9.8
Homepage: http://github.com/trapexit/mergerfs
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mergerfs.git
Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mergerfs.git

Package: mergerfs
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libfuse2
Description: another FUSE union filesystem
 mergerfs is a union filesystem geared towards simplifying storage and
 management of files across numerous commodity storage devices. It is
 similar to mhddfs, unionfs, and aufs.
 .
 Some salient features include
  * Runs in userspace (FUSE)
  * Configurable behaviors
  * Support for extended attributes (xattrs)
  * Support for file attributes (chattr)
  * Runtime configurable (via xattrs)
  * Safe to run as root
  * Opportunistic credential caching
  * Works with heterogeneous filesystem types
  * Handling of writes to full drives
  * Handles pool of readonly and read/write drives

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 include /usr/share/dpkg/buildflags.mk
 
 %:
-	dh $@
+	dh $@ --parallel
 
 override_dh_auto_install:
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install

## mergerfs 2.24.2

=== Makefile ===
--- 
+++ 
@@ -12,8 +12,6 @@
 #  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 #  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 
-
-PKGCONFIG =  	$(shell which pkg-config)
 GIT 	  = 	$(shell which git)
 TAR 	  = 	$(shell which tar)
 MKDIR     = 	$(shell which mkdir)
@@ -30,34 +28,19 @@
 GZIP      =     $(shell which gzip)
 RPMBUILD  =     $(shell which rpmbuild)
 GIT2DEBCL =     ./tools/git2debcl
-CPPFIND   =     ./tools/cppfind
-
-ifeq ($(PKGCONFIG),"")
-$(error "pkg-config not installed")
-endif
-
-ifeq ($(PANDOC),"")
+
+GIT_REPO = 0
+ifneq ($(GIT),)
+ifeq  ($(shell test -e .git; echo $$?),0)
+GIT_REPO = 1
+endif
+endif
+
+ifeq ($(PANDOC),)
 $(warning "pandoc does not appear available: manpage won't be buildable")
 endif
 
 XATTR_AVAILABLE = $(shell test ! -e /usr/include/attr/xattr.h; echo $$?)
-
-FUSE_AVAILABLE = $(shell ! pkg-config --exists fuse; echo $$?)
-
-ifeq ($(FUSE_AVAILABLE),0)
-FUSE_AVAILABLE = $(shell test ! -e /usr/include/fuse.h; echo $$?)
-endif
-
-ifeq ($(FUSE_AVAILABLE),0)
-$(error "FUSE development package doesn't appear available")
-endif
-
-FLAG_NOPATH = $(shell $(CPPFIND) "flag_nopath")
-FLAG_UTIME  = $(shell $(CPPFIND) "flag_utime_omit_ok")
-FALLOCATE   = $(shell $(CPPFIND) "fuse_fs_fallocate")
-FLOCK       = $(shell $(CPPFIND) "fuse_fs_flock")
-READ_BUF    = $(shell $(CPPFIND) "fuse_fs_read_buf")
-WRITE_BUF   = $(shell $(CPPFIND) "fuse_fs_write_buf")
 
 UGID_USE_RWLOCK = 0
 
@@ -67,21 +50,15 @@
 DEPS        = $(OBJ:obj/%.o=obj/%.d)
 TARGET      = mergerfs
 MANPAGE     = $(TARGET).1
-FUSE_CFLAGS = $(shell $(PKGCONFIG) --cflags fuse)
+FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -Ilibfuse/include
 CFLAGS      = -g -Wall \
 	      $(OPTS) \
 	      -Wno-unused-result \
               $(FUSE_CFLAGS) \
               -DFUSE_USE_VERSION=29 \
               -MMD \
-	      -DFLAG_NOPATH=$(FLAG_NOPATH) \
-	      -DFLAG_UTIME=$(FLAG_UTIME) \
-	      -DFALLOCATE=$(FALLOCATE) \
-              -DFLOCK=$(FLOCK) \
-	      -DREAD_BUF=$(READ_BUF) \
-              -DWRITE_BUF=$(WRITE_BUF) \
 	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
-LDFLAGS       = $(shell $(PKGCONFIG) fuse --libs)
+LDFLAGS       = -pthread -lrt
 
 PREFIX        = /usr/local
 EXEC_PREFIX   = $(PREFIX)
@@ -107,24 +84,25 @@
 	@echo "usage: make"
 	@echo "make XATTR_AVAILABLE=0 - to build program without xattrs functionality (auto discovered otherwise)"
 
-$(TARGET): src/version.hpp obj/obj-stamp $(OBJ)
-	$(CXX) $(CFLAGS) $(OBJ) -o $@ $(LDFLAGS)
+$(TARGET): version obj/obj-stamp libfuse/lib/.libs/libfuse.a $(OBJ)
+	cd libfuse && make
+	$(CXX) $(CFLAGS) $(OBJ) -o $@ libfuse/lib/.libs/libfuse.a -ldl $(LDFLAGS)
 
 mount.mergerfs: $(TARGET)
 	$(LN) -fs "$<" "$@"
 
 changelog:
+ifeq ($(GIT_REPO),1)
 	$(GIT2DEBCL) --name $(TARGET) > ChangeLog
+endif
 
 authors:
+ifeq ($(GIT_REPO),1)
 	$(GIT) log --format='%aN <%aE>' | sort -f | uniq > AUTHORS
-
-src/version.hpp:
-	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
-	@echo "#ifndef _VERSION_HPP" > src/version.hpp
-	@echo "#define _VERSION_HPP" >> src/version.hpp
-	@echo "static const char MERGERFS_VERSION[] = \"$(VERSION)\";" >> src/version.hpp
-	@echo "#endif" >> src/version.hpp
+endif
+
+version:
+	tools/update-version
 
 obj/obj-stamp:
 	$(MKDIR) -p obj
@@ -133,18 +111,18 @@
 obj/%.o: src/%.cpp
 	$(CXX) $(CFLAGS) -c $< -o $@
 
-clean: rpm-clean
-ifneq ($(GIT),)
-ifeq  ($(shell test -e .git; echo $$?),0)
+clean: rpm-clean libfuse_Makefile
 	$(RM) -f src/version.hpp
-endif
-endif
 	$(RM) -rf obj
 	$(RM) -f "$(TARGET)" mount.mergerfs
 	$(FIND) . -name "*~" -delete
-
-distclean: clean
+	cd libfuse && $(MAKE) clean
+
+distclean: clean libfuse_Makefile
+	cd libfuse && $(MAKE) distclean
+ifeq ($(GIT_REPO),1)
 	$(GIT) clean -fd
+endif
 
 install: install-base install-mount.mergerfs install-man
 
@@ -175,14 +153,14 @@
 	$(RM) -f "$(INSTALLMAN1DIR)/$(MANPAGE)"
 
 $(MANPAGE): README.md
-ifneq (,$(PANDOC))
+ifneq ($(PANDOC),)
 	$(PANDOC) -s -t man -o "man/$(MANPAGE)" README.md
 endif
 
 man: $(MANPAGE)
 
-tarball: clean man changelog authors src/version.hpp
-	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
+tarball: distclean man changelog authors version
+	$(eval VERSION := $(shell cat VERSION))
 	$(eval VERSION := $(subst -,_,$(VERSION)))
 	$(eval FILENAME := $(TARGET)-$(VERSION))
 	$(eval TMPDIR := $(shell $(MKTEMP) --tmpdir -d .$(FILENAME).XXXXXXXX))
@@ -192,7 +170,11 @@
 	$(RM) -rf $(TMPDIR)
 
 debian-changelog:
+ifeq ($(GIT_REPO),1)
 	$(GIT2DEBCL) --name $(TARGET) > debian/changelog
+else
+	cp ChangeLog debian/changelog
+endif
 
 signed-deb: debian-changelog
 	dpkg-buildpackage
@@ -204,7 +186,7 @@
 	$(RM) -rf rpmbuild
 
 rpm: tarball
-	$(eval VERSION := $(shell $(GIT) describe --always --tags --dirty))
+	$(eval VERSION := $(shell cat VERSION))
 	$(eval VERSION := $(subst -,_,$(VERSION)))
 	$(MKDIR) -p rpmbuild/BUILD rpmbuild/RPMS rpmbuild/SOURCES
 	$(SED) 's/__VERSION__/$(VERSION)/g' $(TARGET).spec > \
@@ -213,6 +195,32 @@
 	$(RPMBUILD) -ba rpmbuild/SOURCES/$(TARGET).spec \
 		--define "_topdir $(CURDIR)/rpmbuild"
 
-.PHONY: all clean install help
-
-include $(wildcard obj/*.d)
+install-build-pkgs:
+ifeq ($(shell test -e /usr/bin/apt-get; echo $$?),0)
+	apt-get -qy update
+	apt-get -qy --no-install-suggests --no-install-recommends --force-yes \
+		install build-essential git g++ debhelper libattr1-dev python automake libtool lsb-release
+else ifeq ($(shell test -e /usr/bin/dnf; echo $$?),0)
+	dnf -y update
+	dnf -y install git rpm-build libattr-devel gcc-c++ make which python automake libtool gettext-devel
+else ifeq ($(shell test -e /usr/bin/yum; echo $$?),0)
+	yum -y update
+	yum -y install git rpm-build libattr-devel gcc-c++ make which python automake libtool gettext-devel
+endif
+
+unexport CFLAGS LDFLAGS
+.PHONY: libfuse_Makefile
+libfuse_Makefile:
+ifeq ($(shell test -e libfuse/Makefile; echo $$?),1)
+	cd libfuse && \
+	$(MKDIR) -p m4 && \
+	autoreconf --force --install && \
+        ./configure --enable-lib --disable-util --disable-example
+endif
+
+libfuse/lib/.libs/libfuse.a: libfuse_Makefile
+	cd libfuse && $(MAKE)
+
+.PHONY: all clean install help version
+
+-include $(DEPS)

=== debian/changelog ===
mergerfs (2.24.2-4) unstable; urgency=medium

  * Fix FTCBFS. Let dh_auto_configure pass --host to libfuse/configure.
    Thanks to Helmut Grohne (Closes: #913842)
  * Filter out the .gitignore file

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 20 Nov 2018 19:23:28 +0530

mergerfs (2.24.2-3) unstable; urgency=medium

  * Switch project hosting to Salsa
  * Add explicit dependency on fuse (Closes: #905502)
  * Add 'use_ino' into example fstab mount options

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 18 Sep 2018 12:02:47 +0545

mergerfs (2.24.2-2) unstable; urgency=medium

  * Upload to Unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 18 May 2018 12:22:12 +0545

mergerfs (2.24.2-1) experimental; urgency=medium

  * New upstream version 2.24.2
  * Refresh patches debian/patches/clean-makefile.patch

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 01 May 2018 09:25:55 +0545

mergerfs (2.23.1-1) experimental; urgency=medium

  * Update d/copyright to reflect license for embedded libfuse
  * New upstream version 2.23.1
  * Update patche clean-makefile.patch

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 28 Dec 2017 19:17:41 +0530

mergerfs (2.23.0+dfsg1-1) experimental; urgency=medium

  * New upstream version 2.23.0+dfsg1
  * Add experimental's gbp config
  * Refresh patches

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 29 Sep 2017 22:33:45 +0545

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,21 @@
 Section: utils
 Priority: optional
 Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~),
+Build-Depends: debhelper (>= 9.0.0), dh-autoreconf, dpkg-dev (>= 1.16.1~),
  libfuse-dev,
  libattr1-dev,
  pkg-config
 Standards-Version: 3.9.8
 Homepage: http://github.com/trapexit/mergerfs
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/mergerfs.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/mergerfs.git
+Vcs-Git: https://salsa.debian.org/debian/mergerfs.git
+Vcs-Browser: https://salsa.debian.org/debian/mergerfs
 
 Package: mergerfs
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- libfuse2
+ libfuse2,
+ fuse
 Description: another FUSE union filesystem
  mergerfs is a union filesystem geared towards simplifying storage and
  management of files across numerous commodity storage devices. It is

=== debian/rules ===
--- 
+++ 
@@ -8,9 +8,14 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
+-include /usr/share/dpkg/buildtools.mk
+export CXX
 
 %:
-	dh $@ --parallel
+	dh $@ --parallel --with=autoreconf
+
+override_dh_auto_configure:
+	dh_auto_configure --sourcedirectory=libfuse -- --enable-lib --disable-util --disable-example
 
 override_dh_auto_install:
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install

## mergerfs 2.28.1

=== Makefile ===
#  Copyright (c) 2016, Antonio SJ Musumeci <trapexit@spawn.link>
#
#  Permission to use, copy, modify, and/or distribute this software for any
#  purpose with or without fee is hereby granted, provided that the above
#  copyright notice and this permission notice appear in all copies.
#
#  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
#  WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
#  MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
#  ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
#  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
#  ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
#  OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

GIT 	  = git
TAR 	  = tar
MKDIR     = mkdir
TOUCH 	  = touch
CP        = cp
RM 	  = rm
LN        = ln
FIND 	  = find
INSTALL   = install
MKTEMP    = mktemp
STRIP     = strip
PANDOC    = pandoc
SED       = sed
RPMBUILD  = rpmbuild
GIT2DEBCL = ./tools/git2debcl
PKGCONFIG = pkg-config

GIT_REPO = 0
ifneq ($(shell $(GIT) --version 2> /dev/null),)
ifeq  ($(shell test -e .git; echo $$?),0)
GIT_REPO = 1
endif
endif

USE_XATTR = 1

FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -Ilibfuse/include

ifeq ($(DEBUG),1)
DEBUG_FLAGS := -g
else
DEBUG_FLAGS :=
endif

ifeq ($(STATIC),1)
STATIC_FLAGS := -static
else
STATIC_FLAGS :=
endif

ifeq ($(LTO),1)
LTO_FLAGS := -flto
else
LTO_FLAGS :=
endif

UGID_USE_RWLOCK = 0

OPTS 	    = -O2
SRC	    = $(wildcard src/*.cpp)
OBJS        = $(SRC:src/%.cpp=build/%.o)
DEPS        = $(SRC:src/%.cpp=build/%.d)
MANPAGE     = mergerfs.1
CXXFLAGS   += \
	      $(OPTS) \
              $(DEBUG_FLAGS) \
              $(STATIC_FLAGS) \
              $(LTO_FLAGS) \
              -Wall \
	      -Wno-unused-result \
              $(FUSE_CFLAGS) \
              -DFUSE_USE_VERSION=29 \
              -MMD \
	      -DUSE_XATTR=$(USE_XATTR) \
	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
LDFLAGS    += \
	      -pthread \
              -lrt

PREFIX        = /usr/local
EXEC_PREFIX   = $(PREFIX)
DATAROOTDIR   = $(PREFIX)/share
DATADIR       = $(DATAROOTDIR)
BINDIR        = $(EXEC_PREFIX)/bin
SBINDIR       = $(EXEC_PREFIX)/sbin
MANDIR        = $(DATAROOTDIR)/man
MAN1DIR       = $(MANDIR)/man1

INSTALLBINDIR  = $(DESTDIR)$(BINDIR)
INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)

.PHONY: all
all: mergerfs

.PHONY: help
help:
	@echo "usage: make\n"
	@echo "make USE_XATTR=0      - build program without xattrs functionality"
	@echo "make STATIC=1         - build static binary"
	@echo "make LTO=1            - build with link time optimization"

objects: version build/stamp
	$(MAKE) $(OBJS)

build/mergerfs: libfuse objects
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)

mergerfs: build/mergerfs

changelog:
ifeq ($(GIT_REPO),1)
	$(GIT2DEBCL) --name mergerfs > ChangeLog
else
	@echo "WARNING: need git repo to generate ChangeLog"
endif

.PHONY: version
version:
	tools/update-version

build/stamp:
	$(MKDIR) -p build
	$(TOUCH) $@

build/%.o: src/%.cpp
	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $@

.PHONY: clean
clean: rpm-clean
	$(RM) -rf build
	$(FIND) . -name "*~" -delete
	$(MAKE) -C libfuse clean

distclean: clean
ifeq ($(GIT_REPO),1)
	$(GIT) clean -xfd
endif

.PHONY: install
install: install-base install-mount.mergerfs install-man

install-base: build/mergerfs
	$(MKDIR) -p "$(INSTALLBINDIR)"
	$(INSTALL) -v -m 0755 build/mergerfs "$(INSTALLBINDIR)/mergerfs"

install-mount.mergerfs: install-base
	$(MKDIR) -p "$(INSTALLBINDIR)"
	$(LN) -s "mergerfs" "$(INSTALLBINDIR)/mount.mergerfs"

install-man: $(MANPAGE)
	$(MKDIR) -p "$(INSTALLMAN1DIR)"
	$(INSTALL) -v -m 0644 "man/$(MANPAGE)" "$(INSTALLMAN1DIR)/$(MANPAGE)"

install-strip: install-base
	$(STRIP) "$(INSTALLBINDIR)/mergerfs"

.PHONY: uninstall
uninstall: uninstall-base uninstall-mount.mergerfs uninstall-man

uninstall-base:
	$(RM) -f "$(INSTALLBINDIR)/mergerfs"

uninstall-mount.mergerfs:
	$(RM) -f "$(INSTALLBINDIR)/mount.mergerfs"

uninstall-man:
	$(RM) -f "$(INSTALLMAN1DIR)/$(MANPAGE)"

$(MANPAGE): README.md
ifneq ($(shell $(PANDOC) --version 2> /dev/null),)
	$(PANDOC) -s -t man -o "man/$(MANPAGE)" README.md
else
	$(warning "pandoc does not appear available: unable to build manpage")
endif

man: $(MANPAGE)

.PHONY: tarball
tarball: man changelog version
	$(eval VERSION := $(shell cat VERSION))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(eval FILENAME := mergerfs-$(VERSION))
	$(eval TMPDIR := $(shell $(MKTEMP) --tmpdir -d .$(FILENAME).XXXXXXXX))
	$(MKDIR) $(TMPDIR)/$(FILENAME)
	$(CP) -ar . $(TMPDIR)/$(FILENAME)
	$(TAR) --exclude=.git -cz -C $(TMPDIR) -f $(FILENAME).tar.gz $(FILENAME)
	$(RM) -rf $(TMPDIR)

debian-changelog:
ifeq ($(GIT_REPO),1)
	$(GIT2DEBCL) --name mergerfs > debian/changelog
else
	cp ChangeLog debian/changelog
endif

signed-deb:
	$(MAKE) distclean
	$(MAKE) debian-changelog
	dpkg-source -b .
	dpkg-buildpackage -nc

deb:
	$(MAKE) distclean
	$(MAKE) debian-changelog
	dpkg-source -b .
	dpkg-buildpackage -nc -uc -us

.PHONY: rpm-clean
rpm-clean:
	$(RM) -rf rpmbuild

rpm: tarball
	$(eval VERSION := $(shell cat VERSION))
	$(eval VERSION := $(subst -,_,$(VERSION)))
	$(MKDIR) -p rpmbuild/BUILD rpmbuild/RPMS rpmbuild/SOURCES
	$(SED) 's/__VERSION__/$(VERSION)/g' mergerfs.spec > \
		rpmbuild/SOURCES/mergerfs.spec
	cp -ar mergerfs-$(VERSION).tar.gz rpmbuild/SOURCES
	$(RPMBUILD) -ba rpmbuild/SOURCES/mergerfs.spec \
		--define "_topdir $(CURDIR)/rpmbuild"

.PHONY: install-build-pkgs
install-build-pkgs:
	tools/install-build-pkgs

.PHONY: libfuse
libfuse:
	$(MAKE) -C libfuse

-include $(DEPS)

=== libfuse/Makefile ===
VERSION = "2.9.7-mergerfs_2.28.0"
OPTS = -O2

ifeq ($(DEBUG),1)
DEBUG_FLAGS := -g
else
DEBUG_FLAGS :=
endif

DESTDIR = "/"
BINDIR = "/bin"
SBINDIR = "/sbin"
SRC   = \
	lib/buffer.c \
	lib/cuse_lowlevel.c \
	lib/fuse.c \
	lib/fuse_kern_chan.c \
	lib/fuse_loop.c \
	lib/fuse_loop_mt.c \
	lib/fuse_lowlevel.c \
	lib/fuse_mt.c \
	lib/fuse_opt.c \
	lib/fuse_session.c \
	lib/fuse_signals.c \
	lib/helper.c \
	lib/mount.c
OBJS = $(SRC:lib/%.c=build/%.o)
DEPS = $(SRC:lib/%.c=build/%.d)

CFLAGS += \
	$(OPTS) \
	$(DEBUG_FLAGS) \
	-Wall \
	-pipe \
	'-D_FILE_OFFSET_BITS=64' \
	'-D_REENTRANT' \
	'-DFUSE_USE_VERSION=29' \
	'-DFUSERMOUNT_DIR="/usr/local/bin"' \
	'-DPACKAGE_VERSION=$(VERSION)' \
	-Iinclude \
	-Ibuild \
	-MMD
LDFLAGS += \
	-lrt \
	-pthread

all: build/libfuse.a

build/config.h: build/stamp
	ecfd/build | tee build/config.h

build/stamp:
	mkdir -p build
	touch $@

objects: build/config.h
	$(MAKE) $(OBJS)

build/libfuse.a: objects
	ar rcs build/libfuse.a $(OBJS)

build/mergerfs-mount: build/config.h util/fusermount.c lib/mount_util.c
	$(CC) $(CFLAGS) -Ilib -o mergerfs-mount util/fusermount.c lib/mount_util.c

build/mount.mergerfs: build/libfuse.a util/mount.fuse.c
	$(CC) $(CFLAGS) -o mount.mergerfs util/mount.fuse.c build/libfuse.a $(LDFLAGS)

build/%.o: lib/%.c
	$(CC) $(CFLAGS) -c $< -o $@

clean:
	rm -rf build

distclean: clean

install: build/mergerfs-mount build/mount.mergerfs
	install -D build/mergerfs-mount "$(DESTDIR)$(BINDIR)/mergerfs-mount"
	chown root:root "$(DESTDIR)$(BINDIR)/mergerfs-mount"
	chmod u+s "$(DESTDIR)$(BINDIR)/mergerfs-mount"
	install -D build/mount.mergerfs "$(DESTDIR)$(SBINDIR)/mount.mergerfs"

.PHONY: objects

-include $(DEPS)

=== debian/changelog ===
mergerfs (2.28.1-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:49:42 +0100

mergerfs (2.28.1-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/copyright: Use https protocol in Format field

  [ Ritesh Raj Sarraf ]
  * New upstream version 2.28.1
  * Drop patches. Not needed anymore
  * Drop autoreconf and autoconf invocation
  * Bump debhelper compatibility to 12
  * Update Standards Version to 4.3.0
  * Use https in homepage field
  * Delete all obsolete patches
  * Drop build dependency on dh-autoreconf and pkg-config
  * Drop --parallel as it is enabed by default
  * Fix d/copyright with LGPL license header

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 15 Jul 2019 11:46:20 +0530

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: utils
 Priority: optional
 Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper (>= 9.0.0), dh-autoreconf, dpkg-dev (>= 1.16.1~),
+Build-Depends: debhelper (>= 12.0.0), dpkg-dev (>= 1.16.1~),
  libfuse-dev,
- libattr1-dev,
- pkg-config
-Standards-Version: 3.9.8
-Homepage: http://github.com/trapexit/mergerfs
+ libattr1-dev
+Standards-Version: 4.3.0
+Homepage: https://github.com/trapexit/mergerfs
 Vcs-Git: https://salsa.debian.org/debian/mergerfs.git
 Vcs-Browser: https://salsa.debian.org/debian/mergerfs

=== debian/rules ===
--- 
+++ 
@@ -12,10 +12,10 @@
 export CXX
 
 %:
-	dh $@ --parallel --with=autoreconf
+	dh $@
 
-override_dh_auto_configure:
-	dh_auto_configure --sourcedirectory=libfuse -- --enable-lib --disable-util --disable-example
+override_dh_autoreconf:
+	# Because there's no auto* files shipped anymore
 
 override_dh_auto_install:
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install

## mergerfs 2.29.0

=== Makefile ===
--- 
+++ 
@@ -37,8 +37,7 @@
 endif
 
 USE_XATTR = 1
-
-FUSE_CFLAGS = -D_FILE_OFFSET_BITS=64 -Ilibfuse/include
+UGID_USE_RWLOCK = 0
 
 ifeq ($(DEBUG),1)
 DEBUG_FLAGS := -g
@@ -58,29 +57,30 @@
 LTO_FLAGS :=
 endif
 
-UGID_USE_RWLOCK = 0
-
-OPTS 	    = -O2
 SRC	    = $(wildcard src/*.cpp)
 OBJS        = $(SRC:src/%.cpp=build/%.o)
 DEPS        = $(SRC:src/%.cpp=build/%.d)
 MANPAGE     = mergerfs.1
-CXXFLAGS   += \
-	      $(OPTS) \
+CXXFLAGS    = \
+              -O2 \
               $(DEBUG_FLAGS) \
               $(STATIC_FLAGS) \
               $(LTO_FLAGS) \
               -Wall \
 	      -Wno-unused-result \
-              $(FUSE_CFLAGS) \
-              -DFUSE_USE_VERSION=29 \
-              -MMD \
+              -MMD
+FUSE_FLAGS = \
+              -Ilibfuse/include \
+              -D_FILE_OFFSET_BITS=64 \
+              -DFUSE_USE_VERSION=29
+MFS_FLAGS  = \
 	      -DUSE_XATTR=$(USE_XATTR) \
 	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
-LDFLAGS    += \
+LDFLAGS    = \
 	      -pthread \
               -lrt
 
+DESTDIR       =
 PREFIX        = /usr/local
 EXEC_PREFIX   = $(PREFIX)
 DATAROOTDIR   = $(PREFIX)/share
@@ -108,7 +108,7 @@
 	$(MAKE) $(OBJS)
 
 build/mergerfs: libfuse objects
-	$(CXX) $(CXXFLAGS) $(CPPFLAGS) $(OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)
+	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) $(OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)
 
 mergerfs: build/mergerfs
 
@@ -128,7 +128,7 @@
 	$(TOUCH) $@
 
 build/%.o: src/%.cpp
-	$(CXX) $(CXXFLAGS) $(CPPFLAGS) -c $< -o $@
+	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) -c $< -o $@
 
 .PHONY: clean
 clean: rpm-clean
@@ -142,15 +142,15 @@
 endif
 
 .PHONY: install
-install: install-base install-mount.mergerfs install-man
+install: install-base install-mount-tools install-man
 
 install-base: build/mergerfs
 	$(MKDIR) -p "$(INSTALLBINDIR)"
 	$(INSTALL) -v -m 0755 build/mergerfs "$(INSTALLBINDIR)/mergerfs"
 
-install-mount.mergerfs: install-base
+install-mount-tools: install-base
 	$(MKDIR) -p "$(INSTALLBINDIR)"
-	$(LN) -s "mergerfs" "$(INSTALLBINDIR)/mount.mergerfs"
+	$(MAKE) -C libfuse install
 
 install-man: $(MANPAGE)
 	$(MKDIR) -p "$(INSTALLMAN1DIR)"

=== libfuse/Makefile ===
VERSION = 2.9.7-mergerfs_2.29.0

ifeq ($(DEBUG),1)
DEBUG_FLAGS := -g
else
DEBUG_FLAGS :=
endif

DESTDIR       =
PREFIX        = /usr/local
EXEC_PREFIX   = $(PREFIX)
DATAROOTDIR   = $(PREFIX)/share
DATADIR       = $(DATAROOTDIR)
BINDIR        = $(EXEC_PREFIX)/bin
SBINDIR       = $(EXEC_PREFIX)/sbin
MANDIR        = $(DATAROOTDIR)/man
MAN1DIR       = $(MANDIR)/man1

INSTALLBINDIR  = $(DESTDIR)$(BINDIR)
INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)

SRC   = \
	lib/buffer.c \
	lib/cuse_lowlevel.c \
	lib/fuse.c \
	lib/fuse_kern_chan.c \
	lib/fuse_loop.c \
	lib/fuse_loop_mt.c \
	lib/fuse_lowlevel.c \
	lib/fuse_mt.c \
	lib/fuse_opt.c \
	lib/fuse_session.c \
	lib/fuse_signals.c \
	lib/helper.c \
	lib/mount.c
OBJS = $(SRC:lib/%.c=build/%.o)
DEPS = $(SRC:lib/%.c=build/%.d)

CFLAGS = \
	-O2 \
	$(DEBUG_FLAGS) \
	-Wall \
	-pipe \
	-MMD
FUSERMOUNT_DIR = $(BINDIR)
FUSE_FLAGS = \
	-Iinclude \
	-Ibuild \
	-D_REENTRANT \
	-D_FILE_OFFSET_BITS=64 \
	-DFUSE_USE_VERSION=29 \
	-DPACKAGE_VERSION=\"$(VERSION)\" \
	-DFUSERMOUNT_DIR=\"$(FUSERMOUNT_DIR)\"
LDFLAGS = \
	-lrt \
	-pthread

all: build/libfuse.a mount.mergerfs mergerfs-fusermount

build/config.h: build/stamp
	ecfd/build | tee build/config.h

build/stamp:
	mkdir -p build
	touch $@

objects: build/config.h
	$(MAKE) $(OBJS)

build/libfuse.a: objects
	ar rcs build/libfuse.a $(OBJS)

build/mergerfs-fusermount: build/config.h util/fusermount.c lib/mount_util.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -Ilib -o build/mergerfs-fusermount util/fusermount.c lib/mount_util.c

mergerfs-fusermount: build/mergerfs-fusermount

build/mount.mergerfs: build/libfuse.a util/mount.mergerfs.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -o build/mount.mergerfs util/mount.mergerfs.c build/libfuse.a $(LDFLAGS)

mount.mergerfs: build/mount.mergerfs

build/%.o: lib/%.c
	$(CC) $(CFLAGS) $(FUSE_FLAGS) -c $< -o $@

clean:
	rm -rf build

distclean: clean

strip:
	strip --strip-all build/mount.mergerfs
	strip --strip-all build/mergerfs-fusermount

install: mergerfs-fusermount mount.mergerfs strip
	install -D build/mergerfs-fusermount "$(INSTALLBINDIR)/mergerfs-fusermount"
	install -D build/mount.mergerfs "$(INSTALLSBINDIR)/mount.mergerfs"
	chown root:root "$(INSTALLBINDIR)/mergerfs-fusermount"
	chmod u+s "$(INSTALLBINDIR)/mergerfs-fusermount"

.PHONY: objects strip

-include $(DEPS)

=== debian/changelog ===
mergerfs (2.29.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: (Closes: #955285)
    + cross.patch: Make strip substitutable in libfuse/Makefile.
    + Override strip for make install.
    + export CC as make install rebuilds parts.

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 07 Apr 2020 12:25:24 +0530

mergerfs (2.29.0-1) unstable; urgency=medium

  * New upstream version 2.29.0
  * Bump Standards Version to 4.5.0
  * Add expiciti dependency to debhelper 12
  * Set DEBUG=1 in build config to generate debug symbols
  * Disable git cleaning during build
  * Add patch to better apply the hardening build flags

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 22 Mar 2020 18:47:17 +0530

## mergerfs 2.31.0

=== Makefile ===
--- 
+++ 
@@ -40,9 +40,9 @@
 UGID_USE_RWLOCK = 0
 
 ifeq ($(DEBUG),1)
-DEBUG_FLAGS := -g
-else
-DEBUG_FLAGS :=
+OPT_FLAGS := -O0 -g
+else
+OPT_FLAGS := -O2
 endif
 
 ifeq ($(STATIC),1)
@@ -61,13 +61,14 @@
 OBJS        = $(SRC:src/%.cpp=build/%.o)
 DEPS        = $(SRC:src/%.cpp=build/%.d)
 MANPAGE     = mergerfs.1
-CXXFLAGS    = \
-              -O2 \
-              $(DEBUG_FLAGS) \
+CXXFLAGS    ?= ${OPT_FLAGS}
+CXXFLAGS    := \
+              ${CXXFLAGS} \
+              -std=c++0x \
               $(STATIC_FLAGS) \
               $(LTO_FLAGS) \
               -Wall \
-	      -Wno-unused-result \
+              -Wno-unused-result \
               -MMD
 FUSE_FLAGS = \
               -Ilibfuse/include \
@@ -76,9 +77,11 @@
 MFS_FLAGS  = \
 	      -DUSE_XATTR=$(USE_XATTR) \
 	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
-LDFLAGS    = \
-	      -pthread \
-              -lrt
+
+LDFLAGS := \
+    ${LDFLAGS} \
+    -pthread \
+    -lrt
 
 DESTDIR       =
 PREFIX        = /usr/local
@@ -230,6 +233,6 @@
 
 .PHONY: libfuse
 libfuse:
-	$(MAKE) -C libfuse
+	$(MAKE) DEBUG=$(DEBUG) -C libfuse
 
 -include $(DEPS)

=== libfuse/Makefile ===
--- 
+++ 
@@ -1,9 +1,18 @@
-VERSION = 2.9.7-mergerfs_2.29.0
+VERSION = 2.9.7-mergerfs_2.30.0
+
+OS := $(shell uname -s)
+ifeq ($(OS),Linux)
+UTILS := utils
+INSTALLUTILS := install-utils
+else
+UTILS :=
+INSTALLUTILS :=
+endif
 
 ifeq ($(DEBUG),1)
-DEBUG_FLAGS := -g
+OPT_FLAGS := -O0 -g
 else
-DEBUG_FLAGS :=
+OPT_FLAGS := -O2
 endif
 
 DESTDIR       =
@@ -12,7 +21,7 @@
 DATAROOTDIR   = $(PREFIX)/share
 DATADIR       = $(DATAROOTDIR)
 BINDIR        = $(EXEC_PREFIX)/bin
-SBINDIR       = $(EXEC_PREFIX)/sbin
+SBINDIR       = /sbin
 MANDIR        = $(DATAROOTDIR)/man
 MAN1DIR       = $(MANDIR)/man1
 
@@ -20,12 +29,13 @@
 INSTALLSBINDIR = $(DESTDIR)$(SBINDIR)
 INSTALLMAN1DIR = $(DESTDIR)$(MAN1DIR)
 
+AR ?= ar
+
 SRC   = \
 	lib/buffer.c \
-	lib/cuse_lowlevel.c \
+	lib/fuse_dirents.c \
 	lib/fuse.c \
 	lib/fuse_kern_chan.c \
-	lib/fuse_loop.c \
 	lib/fuse_loop_mt.c \
 	lib/fuse_lowlevel.c \
 	lib/fuse_mt.c \
@@ -36,10 +46,10 @@
 	lib/mount.c
 OBJS = $(SRC:lib/%.c=build/%.o)
 DEPS = $(SRC:lib/%.c=build/%.d)
-
-CFLAGS = \
-	-O2 \
-	$(DEBUG_FLAGS) \
+CFLAGS ?= \
+	$(OPT_FLAGS)
+CFLAGS := \
+    ${CFLAGS} \
 	-Wall \
 	-pipe \
 	-MMD
@@ -52,11 +62,12 @@
 	-DFUSE_USE_VERSION=29 \
 	-DPACKAGE_VERSION=\"$(VERSION)\" \
 	-DFUSERMOUNT_DIR=\"$(FUSERMOUNT_DIR)\"
-LDFLAGS = \
+LDFLAGS := \
+	${LDFLAGS} \
 	-lrt \
 	-pthread
 
-all: build/libfuse.a mount.mergerfs mergerfs-fusermount
+all: build/libfuse.a $(UTILS)
 
 build/config.h: build/stamp
 	ecfd/build | tee build/config.h
@@ -69,7 +80,9 @@
 	$(MAKE) $(OBJS)
 
 build/libfuse.a: objects
-	ar rcs build/libfuse.a $(OBJS)
+	${AR} rcs build/libfuse.a $(OBJS)
+
+utils: mergerfs-fusermount mount.mergerfs
 
 build/mergerfs-fusermount: build/config.h util/fusermount.c lib/mount_util.c
 	$(CC) $(CFLAGS) $(FUSE_FLAGS) -Ilib -o build/mergerfs-fusermount util/fusermount.c lib/mount_util.c
@@ -93,12 +106,14 @@
 	strip --strip-all build/mount.mergerfs
 	strip --strip-all build/mergerfs-fusermount
 
-install: mergerfs-fusermount mount.mergerfs strip
+install-utils: mergerfs-fusermount mount.mergerfs strip
 	install -D build/mergerfs-fusermount "$(INSTALLBINDIR)/mergerfs-fusermount"
 	install -D build/mount.mergerfs "$(INSTALLSBINDIR)/mount.mergerfs"
-	chown root:root "$(INSTALLBINDIR)/mergerfs-fusermount"
+	chown root "$(INSTALLBINDIR)/mergerfs-fusermount"
 	chmod u+s "$(INSTALLBINDIR)/mergerfs-fusermount"
 
-.PHONY: objects strip
+install: $(INSTALLUTILS)
+
+.PHONY: objects strip utils install install-utils
 
 -include $(DEPS)

=== debian/changelog ===
mergerfs (2.31.0-1ubuntu1) hirsute; urgency=medium

  * Skip dh_dwz, as it fails on ppc64el and s390x (LP: #1903748)

 -- Lukas Märdian <slyon@ubuntu.com>  Wed, 17 Feb 2021 11:28:08 +0100

mergerfs (2.31.0-1) unstable; urgency=medium

  * New upstream version 2.31.0
  * Refresh patches
  * Make patches pq clean

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 07 Oct 2020 13:28:41 +0530

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: mergerfs
 Section: utils
 Priority: optional
-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper (>= 12.0.0), dpkg-dev (>= 1.16.1~),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
+Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.1~),
  libfuse-dev,
  libattr1-dev
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://github.com/trapexit/mergerfs
 Vcs-Git: https://salsa.debian.org/debian/mergerfs.git
 Vcs-Browser: https://salsa.debian.org/debian/mergerfs

=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,12 @@
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/buildflags.mk
 -include /usr/share/dpkg/buildtools.mk
+export CC
 export CXX
+export DEBUG = 1
+
+# Disable git calling for cleaning
+export GIT_REPO = 0
 
 %:
 	dh $@
@@ -18,4 +23,7 @@
 	# Because there's no auto* files shipped anymore
 
 override_dh_auto_install:
-	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install
+	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install STRIP=true
+
+override_dh_dwz:
+	-dh_dwz

## mergerfs 2.32.6

=== debian/changelog ===
mergerfs (2.32.6-1) unstable; urgency=medium

  * New upstream version 2.32.6
  * Bump debhelper compatibility to 13

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 17 Aug 2021 15:45:51 +0530

## mergerfs 2.33.3

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 UGID_USE_RWLOCK = 0
 
 ifeq ($(DEBUG),1)
-OPT_FLAGS := -O0 -g
+OPT_FLAGS := -O0 -g -fsanitize=undefined
 else
 OPT_FLAGS := -O2
 endif
@@ -58,13 +58,20 @@
 endif
 
 SRC	    = $(wildcard src/*.cpp)
-OBJS        = $(SRC:src/%.cpp=build/%.o)
-DEPS        = $(SRC:src/%.cpp=build/%.d)
+OBJS        = $(SRC:src/%.cpp=build/.src/%.o)
+DEPS        = $(SRC:src/%.cpp=build/.src/%.d)
+
+TESTS       = $(wildcard tests/*.cpp)
+TESTS_OBJS  = $(filter-out build/.src/mergerfs.o,$(OBJS))
+TESTS_OBJS += $(TESTS:tests/%.cpp=build/.tests/%.o)
+TESTS_DEPS  = $(TESTS:tests/%.cpp=build/.tests/%.d)
+TESTS_DEPS += $(DEPS)
+
 MANPAGE     = mergerfs.1
 CXXFLAGS    ?= ${OPT_FLAGS}
 CXXFLAGS    := \
               ${CXXFLAGS} \
-              -std=c++0x \
+              -std=c++11 \
               $(STATIC_FLAGS) \
               $(LTO_FLAGS) \
               -Wall \
@@ -77,6 +84,9 @@
 MFS_FLAGS  = \
 	      -DUSE_XATTR=$(USE_XATTR) \
 	      -DUGID_USE_RWLOCK=$(UGID_USE_RWLOCK)
+TESTS_FLAGS = \
+              -Isrc \
+              -DTESTS
 
 LDFLAGS := \
     ${LDFLAGS} \
@@ -110,10 +120,18 @@
 objects: version build/stamp
 	$(MAKE) $(OBJS)
 
+tests-objects:
+	$(MAKE) $(TESTS_OBJS)
+
 build/mergerfs: libfuse objects
 	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) $(OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)
 
+build/tests: build/mergerfs tests-objects
+	$(CXX) $(CXXFLAGS) $(TESTS_FLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) $(TESTS_OBJS) -o $@ libfuse/build/libfuse.a $(LDFLAGS)
+
 mergerfs: build/mergerfs
+
+tests: build/tests
 
 changelog:
 ifeq ($(GIT_REPO),1)
@@ -127,11 +145,15 @@
 	tools/update-version
 
 build/stamp:
-	$(MKDIR) -p build
+	$(MKDIR) -p build/.src build/.tests
 	$(TOUCH) $@
 
-build/%.o: src/%.cpp
+build/.src/%.o: src/%.cpp
 	$(CXX) $(CXXFLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) -c $< -o $@
+
+build/.tests/%.o: tests/%.cpp
+	$(CXX) $(CXXFLAGS) $(TESTS_FLAGS) $(FUSE_FLAGS) $(MFS_FLAGS) $(CPPFLAGS) -c $< -o $@
+
 
 .PHONY: clean
 clean: rpm-clean

=== debian/changelog ===
mergerfs (2.33.3-1) unstable; urgency=medium

  * New upstream version 2.33.3
  * Refresh patches
  * Update copyright year

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 16 Feb 2022 13:51:06 +0530

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: mergerfs
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper-compat (= 12), dpkg-dev (>= 1.16.1~),
+Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
+Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~),
  libfuse-dev,
  libattr1-dev
 Standards-Version: 4.5.0

## mergerfs 2.33.5

=== libfuse/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 endif
 
 ifeq ($(DEBUG),1)
-OPT_FLAGS := -O0 -g
+OPT_FLAGS := -O0 -g -fsanitize=undefined
 else
 OPT_FLAGS := -O2
 endif
@@ -33,12 +33,15 @@
 
 SRC   = \
 	lib/buffer.c \
+	lib/crc32b.c \
+	lib/debug.c \
+	lib/fuse.c \
 	lib/fuse_dirents.c \
-	lib/fuse.c \
 	lib/fuse_kern_chan.c \
 	lib/fuse_loop_mt.c \
 	lib/fuse_lowlevel.c \
 	lib/fuse_mt.c \
+	lib/fuse_node.c \
 	lib/fuse_opt.c \
 	lib/fuse_session.c \
 	lib/fuse_signals.c \
@@ -49,7 +52,8 @@
 CFLAGS ?= \
 	$(OPT_FLAGS)
 CFLAGS := \
-    ${CFLAGS} \
+	${CFLAGS} \
+	-std=gnu99 \
 	-Wall \
 	-pipe \
 	-MMD

=== debian/changelog ===
mergerfs (2.33.5-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:55:41 +1100

mergerfs (2.33.5-1ubuntu1) noble; urgency=medium

  * Don't hard-code dependency on shared library.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Mar 2024 19:21:40 +0100

mergerfs (2.33.5-1build1) noble; urgency=high

  * No change rebuild against libfuse2t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Fri, 22 Mar 2024 17:44:11 +0100

mergerfs (2.33.5-1) unstable; urgency=medium

  * New upstream version 2.33.5

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 02 Sep 2022 17:00:28 +0530

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mergerfs
 Section: utils
 Priority: optional
-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
 Build-Depends: debhelper-compat (= 13), dpkg-dev (>= 1.16.1~),
  libfuse-dev,
  libattr1-dev
@@ -14,7 +15,7 @@
 Architecture: any
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- libfuse2,
+ ${lib:Depends},
  fuse
 Description: another FUSE union filesystem
  mergerfs is a union filesystem geared towards simplifying storage and

=== debian/rules ===
--- 
+++ 
@@ -25,5 +25,7 @@
 override_dh_auto_install:
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mergerfs PREFIX=/usr install STRIP=true
 
-override_dh_dwz:
-	-dh_dwz
+override_dh_gencontrol:
+	dh_gencontrol -- \
+	  -Vlib:Depends=$(shell dpkg-query -W -f '$${Depends}' libfuse-dev \
+			| sed -E 's/.*(libfuse[[:alnum:].-]+).*/\1/')
